'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _interopRequireDefault = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _Bacon = require('sigh-core');

var _import = require('lodash');

var _import2 = _interopRequireDefault(_import);

var _mapEvents = require('sigh-core/lib/stream');

function eventCompiler(opts) {
  var babel = require('babel');
  var _ = require('lodash');

  return function (event) {
    var babelOpts = {
      modules: opts.modules,
      filename: event.path,
      sourceMap: true,
      moduleIds: true
    };

    if (opts.modules !== 'common') {
      var modulePath = event.projectPath.replace(/\.js$/, '');
      if (opts.getModulePath) modulePath = opts.getModulePath(modulePath);
      babelOpts.moduleId = modulePath;
    }

    // if (event.basePath)
    //   babelOpts.filenameRelative = event.basePath

    var result = babel.transform(event.data, babelOpts);
    return _.pick(result, 'code', 'map');
  };
}

// (de)serialise argument to and result of babel subprocess
function adaptEvent(compiler) {
  return function (event) {
    if (event.type !== 'add' && event.type !== 'change') return event;

    var fileType = event.fileType;

    if (fileType !== 'js' && fileType !== 'es6') return event;

    var result = compiler(_import2['default'].pick(event, 'type', 'data', 'path', 'projectPath'));

    // without proc pool a Promise.resolve is needed here
    return result.then(function (result) {
      event.data = result.code;
      event.applySourceMap(result.map);
      return event;
    });
  };
}

var pooledProc;

exports['default'] = function (op, opts) {
  opts = _import2['default'].assign({ modules: 'amd' }, opts || {});

  // without proc pool:
  // return mapEvents(op.stream, adaptEvent(eventCompiler(opts)))

  if (!pooledProc) pooledProc = op.procPool.prepare(eventCompiler, opts);

  return _mapEvents.mapEvents(op.stream, adaptEvent(pooledProc));
};

module.exports = exports['default'];
//# sourceMappingURL=index.js.map